/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_ipi.h 79 2009-01-22 02:39:06Z ertl-honda $
 */

/*
 *  ץåֳߥɥ饤СCT11MPCOREѡ
 */

#ifndef TOPPERS_TARGET_IPI_H
#define TOPPERS_TARGET_IPI_H

#include "mpcore.h"

/*
 *  ץåֳߤȤѤߤDICֹ
 */
#define DIC_IRQNO_IPI  DIC_IRQNO_IPI0

/*
 *  ץåֳߤγֹ
 */
#define INTNO_IPI_PRC1   (0x00010000 | DIC_IRQNO_IPI)
#define INTNO_IPI_PRC2   (0x00020000 | DIC_IRQNO_IPI)
#define INTNO_IPI_PRC3   (0x00040000 | DIC_IRQNO_IPI)
#define INTNO_IPI_PRC4   (0x00080000 | DIC_IRQNO_IPI)

/*
 *  ץåֳߤγߥϥɥֹ
 */
#define INHNO_IPI_PRC1   (0x00010000 | DIC_IRQNO_IPI)
#define INHNO_IPI_PRC2   (0x00020000 | DIC_IRQNO_IPI)
#define INHNO_IPI_PRC3   (0x00040000 | DIC_IRQNO_IPI)
#define INHNO_IPI_PRC4   (0x00080000 | DIC_IRQNO_IPI)

/*
 *  ץåֳߤγͥ
 */
#define INTPRI_IPI_PRC1   (-2)
#define INTPRI_IPI_PRC2   (-2)
#define INTPRI_IPI_PRC3   (-2)
#define INTPRI_IPI_PRC4   (-2)

/*
 *  åװ¸⥸塼MPCOREѡ
 */
#include "arm_gcc/mpcore/chip_ipi.h"

#endif /* TOPPERS_TARGET_IPI_H */
