/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 * 
 *  Copyright (C) 2007-2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: test_mact_tsk1.c 175 2009-03-03 13:19:45Z ertl-kikuchi $
 */

/* 
 *		mact_tskӥΥƥ(1)
 *  ڥƥȤŪ
 *    оݥٻ߾֤ΥФơmact_tskȯԤ롥
 *    ץå˳դ줿¾ץåذưѥ
 *    ƥȤ롥
 *
 *  ڥƥȹܡ
 *    ưCPUΥǥ塼Ǥΰ֤ˤʬԤ
 *
 *    (2-A) ǹͥ
 *    (2-B) ¹Ծ֤ΥƱͥ
 *    (2-C) ¹Ծ֤Υͥ
 *    (2-D) ǥ塼ΤȤذư
 */


#include <kernel.h>
#include <t_syslog.h>
#include <sil.h>
#include "kernel_cfg.h"
#include "test_lib.h"

void
task1_1(intptr_t exinf)
{
	ER		ercd;

	check_point(1);

	check_point(2);
	ercd = act_tsk(TASK2_2);
	check_ercd(ercd, E_OK);

	check_point(3);
	ercd = slp_tsk();
	check_ercd(ercd, E_OK);

	check_point(0);
 
}

void
task1_4(intptr_t exinf)
{
	ER		ercd;
	FLGPTN  flgptn;

	check_point(1);
	ercd = mact_tsk(TASK1_1,2);
	check_ercd(ercd, E_OK);

	//Ʊե饰Ԥ 2-2Ԥ
	do{
		ercd = pol_flg(FLG1,1,TWF_ANDW,&flgptn);
	}while(ercd != E_OK);

	check_point(2);
	ercd = mact_tsk(TASK1_2,2);
	check_ercd(ercd, E_OK);

	check_point(3);
	ercd = mact_tsk(TASK1_5,2);
	check_ercd(ercd, E_OK);

	check_point(4);
	ercd = mact_tsk(TASK1_7,2);
	check_ercd(ercd, E_OK);
   
	check_finish(5);//1
}

void
task1_2(intptr_t exinf)
{
	ER		ercd;
 
	check_point(5);
	//Ʊե饰å 2_2
	ercd = set_flg(FLG1,2);
	check_ercd(ercd, E_OK);
   
	ercd = slp_tsk();
	check_ercd(ercd, E_OK);
    
	check_point(0);
}

void
task1_5(intptr_t exinf)
{
	ER		ercd;

	check_point(7);
	ercd = slp_tsk();
	check_ercd(ercd, E_OK);
    
	check_point(0);
}

void
task1_7(intptr_t exinf)
{
	/*ƥȽλ*/
	check_finish(8);//2
}

void
task2_2(intptr_t exinf)
{
	ER		ercd;
	FLGPTN  flgptn;

	check_point(4);
  
	ercd = set_flg(FLG1,1);
	check_ercd(ercd, E_OK);
  
	//Ʊե饰Ԥ 1_2εưԤ
	do{
		ercd = pol_flg(FLG1,2,TWF_ANDW,&flgptn);
	}while(ercd != E_OK);
  
	check_point(6);
	ercd = slp_tsk();
	check_ercd(ercd, E_OK);

	check_point(0);
}
