/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2008-2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_syssvc.h 129 2009-02-02 05:23:49Z ertl-honda $
 */

/*
 *  ƥॵӥΥåȰ¸NaviEngineѡ
 *
 *  ƥॵӥΥåȰ¸Υ󥯥롼ɥե롥Υե
 *  Ƥϡݡͥȵҥե˵Ҥ졤Υե
 *  ̵ʤ븫ߡ
 */

#ifndef TOPPERS_TARGET_SYSSVC_H
#define TOPPERS_TARGET_SYSSVC_H

/*
 *  åȥƥΥϡɥ񸻤
 */
#include "naviengine.h"
#include "arm_gcc/mpcore/mpcore.h"

/*
 *  ȥ졼˴ؤ
 */
#ifdef TOPPERS_ENABLE_TRACE
#include "logtrace/trace_config.h"
#endif /* TOPPERS_ENABLE_TRACE */

/*
 *  ưåΥåȥƥ̾
 */
#define TARGET_NAME    "ARM NaviEngine(11MPCore)"

/*
 *  ƥ٥ϤΤʸ
 *
 *  åȰ¸ˡǡʸcɽ//¸롥
 */
extern void	target_fput_log(char_t c);

/*
 *  ݡȤ륷ꥢݡȤο
 */
#ifdef G_SYSLOG
#define TNUM_PORT       1
#else
#define TNUM_PORT       TNUM_PRC
#endif /* G_SYSLOG */

#define INHNO_SIO0   (0xf0000 | DIC_IRQNO_UART0)   /* UART0ߥϥɥֹ */
#define INTNO_SIO0   (0xf0000 | DIC_IRQNO_UART0)   /* UART0ֹ */
#define INHNO_SIO1   (0xf0000 | DIC_IRQNO_UART1)   /* UART1ߥϥɥֹ */
#define INTNO_SIO1   (0xf0000 | DIC_IRQNO_UART1)   /* UART1ֹ */
#define INHNO_SIO2   (0xf0000 | DIC_IRQNO_UART2)   /* UART2ߥϥɥֹ */
#define INTNO_SIO2   (0xf0000 | DIC_IRQNO_UART2)   /* UART2ֹ */
#define INHNO_SIO3   (0xf0000 | DIC_IRQNO_UART3)   /* UART3ߥϥɥֹ */
#define INTNO_SIO3   (0xf0000 | DIC_IRQNO_UART3)   /* UART3ֹ */

#define INTPRI_SIO0       -2              /* UARTͥ */
#define INTATR_SIO0       0U              /* UART° */
#define INTPRI_SIO1       -2              /* UARTͥ */
#define INTATR_SIO1       0U              /* UART° */
#define INTPRI_SIO2       -2              /* UARTͥ */
#define INTATR_SIO2       0U              /* UART° */
#define INTPRI_SIO3       -2              /* UARTͥ */
#define INTATR_SIO3       0U              /* UART° */

/*
 *  ƥϢ
 *
 *  ǥե̤ͤꡥ
 */

#endif /* TOPPERS_TARGET_SYSSVC_H */
