/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 * 
 *  Copyright (C) 2007,2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: test_mig_tsk2.c 175 2009-03-03 13:19:45Z ertl-kikuchi $
 */

/* 
 *		mig_tskӥΥƥ(2)
 *  ڥƥȤŪ
 *    оݥ¹Ծ֤ΥФơmig_tskȯԤ롥
 *
 *  ڥƥȹܡ
 *    ưCPUΥǥ塼Ǥΰ֤ˤʬԤ
 *
 *    (1-F) ǹͥ
 *    (1-G) ¹Ծ֤ΥƱͥ
 *    (1-H) ¹Ծ֤Υͥ
 *    (1-I) ǥ塼ΤȤذư
 */


#include <kernel.h>
#include <t_syslog.h>
#include <sil.h>
#include "kernel_cfg.h"
#include "test_lib.h"

void
task1_1(intptr_t exinf)
{
	ER		ercd;
	ID    cpuno;

	check_point(1);//1
	ercd = mig_tsk(TASK1_1,2);
	check_ercd(ercd, E_OK);

	do{
		get_pid(&cpuno);
	}while(cpuno==1);

	check_point(1);//2
	ercd = act_tsk(TASK2_2);
	check_ercd(ercd, E_OK);

	check_point(2);//2
	ercd = act_tsk(TASK2_3);
	check_ercd(ercd, E_OK);

	check_point(3);//2
	ercd = slp_tsk();
	check_ercd(ercd, E_OK);

	check_point(0);
}
  
void
task1_4(intptr_t exinf)
{
	ER		ercd;
	FLGPTN  flgptn;

	//Ʊե饰å 2_2˵ư

	check_point(2);//1
	ercd = set_flg(FLG1,2);
	check_ercd(ercd, E_OK);

	//Ʊե饰Ԥ 2_3εưԤ
	do{
		ercd = pol_flg(FLG1,0x10,TWF_ANDW,&flgptn);
	}while(ercd != E_OK);

	check_point(3);//1
	ercd = mig_tsk(TASK1_4,2);
	check_ercd(ercd, E_OK);

	check_point(8);//2
	ercd = slp_tsk();
	check_ercd(ercd, E_OK);

	check_point(0);
}

void
task1_6(intptr_t exinf)
{
	ER		ercd;
	FLGPTN  flgptn;

	check_point(7);//1

	//Ʊե饰Ԥ 1_7ΰưԤ
	do{
		ercd = pol_flg(FLG1,1,TWF_ANDW,&flgptn);
	}while(ercd != E_OK);

	check_point(8);//1

	ercd = mig_tsk(TASK1_6,2);
	check_ercd(ercd, E_OK);

	//Ʊե饰å 1-7˰ư
	check_point(10);//2
	ercd = set_flg(FLG1,8);
	check_ercd(ercd, E_OK);

	check_point(11);//2
	ercd = slp_tsk();
	check_ercd(ercd, E_OK);

	check_point(0);
}

void
task1_7(intptr_t exinf)
{
	ER		ercd;
	FLGPTN  flgptn;

	//Ʊե饰å 2-3˵ư
	check_point(4);//1
	ercd = set_flg(FLG1,4);
	check_ercd(ercd, E_OK);

	check_point(5);//1
	ercd = mig_tsk(TASK1_7,2);
	check_ercd(ercd, E_OK);

	//Ʊե饰å 1-6˰ư
	check_point(9);//2
	ercd = set_flg(FLG1,1);
	check_ercd(ercd, E_OK);

	//Ʊե饰Ԥ 1_6ΰưԤ
	do{
		ercd = pol_flg(FLG1,8,TWF_ANDW,&flgptn);
	}while(ercd != E_OK);


	/*ƥȽλ*/
	check_finish(12);//CPU2
}

void
task1_9(intptr_t exinf)
{
	ER		ercd;

	check_point(6);//1
	ercd = act_tsk(TASK1_6);
	check_ercd(ercd, E_OK);

	/*ƥȽλ*/
	check_finish(9);//1
}

void
task2_2(intptr_t exinf)
{
	ER		ercd;
	FLGPTN  flgptn;

	check_point(4);

	//Ʊե饰Ԥ 1_4εưԤ
	do {
		ercd = pol_flg(FLG1,2,TWF_ANDW,&flgptn);
	}while(ercd != E_OK);

	check_point(5);//2
	ercd = slp_tsk();
	check_ercd(ercd, E_OK);

	check_point(0);
}

void
task2_3(intptr_t exinf)
{
	ER		ercd;
	FLGPTN flgptn;

	check_point(6);//2

	ercd = set_flg(FLG1,0x10); 

	//Ʊե饰Ԥ1_7εưԤ
	do{
		ercd = pol_flg(FLG1,4,TWF_ANDW,&flgptn);
	}while(ercd != E_OK);

	check_point(7);//2
	ercd = slp_tsk();
	check_ercd(ercd, E_OK);

	check_point(0);
}
